import numpy as np

D = np.empty  
P1 = np.empty 
P2 = np.empty
A1 = np.empty
Z1 = np.empty
A2 = np.empty
Z2 = np.empty
vw  = np.empty
 
def inicializa_red( ) :
	global D, P1, P2, vw
	global Z1, A1, Z2, A2
	D = np.loadtxt( "1dato.txt" )
	np.random.seed(1)
	# Para guardar 
	Z1 = np.zeros( (1,2) )
	A1 = np.zeros( (1,3) )

	Z2 = np.zeros( (1,1) )
	A2 = np.zeros( (1,1) )
	vw = np.zeros( (1,3) )

	P1 = np.zeros( (3,2) )
	P2 = np.zeros( (3,1) )


# Son 9 datos, entonces los copiamos a un vector
# 1. Tenemos un individuo
# 2. Copiamos los datos del vector del individuo 
#    a las matrices P1 y P2
# 3. Evaluamos el individuo

# Los pesos del ejemplo del libro de Gonzalez y Woods:
# P1 = np.array( [ [ 4.792, 4.792 ],
#                  [ 4.486, 4.486 ],
#                  [ 4.590,-4.486 ] ] )
# 
# P2 = np.array( [ [ -9.180 ],
#                  [  9.178 ],
#                  [  4.420 ] ] )



def sigmoide( x ) :
	return 1.0/(1.0+np.exp(-x))

# La entrada debe ser un vector de tamaño (1,3)
# el último debe ser igual a 1 (para representar el sesgo)
def hacia_adelante( Entradas ) : 


	# Realizamos los cálculos en la primera capa
	#      1x3      3x2 = 1x2   
	Z1 = Entradas @ P1 

	A1[0,0:2] = sigmoide( Z1 )
	A1[0,2] = 1.0

	###########################
	#    1x3  3x1  = 1x1
	Z2 = A1 @ P2 
	A2[0,0] = sigmoide( Z2 )

	return A2[0,0]

def Evaluate( _n, vv ) :
	i = 0
	while i < 3 :
		P1[i,0] = vv[i] 
		P1[i,1] = vv[3+i]	
		P2[i,0] = vv[6+i]	
		i += 1

	error = 0.0

	j = 0
	while j < 4 :
		vw[0,:] = [ D[j,0], D[j,1], 1.0 ]
		s = hacia_adelante( vw )
		k = s-D[j,2]
		error += k*k
		j += 1
	
	return np.sqrt(error/4)

